### Method

# EDataServer OAuth2Service get_access_token_sync

since: 3.28

#### Declaration [src]

    gboolean
    e_oauth2_service_get_access_token_sync (
      EOAuth2Service* service,
      ESource* source,
      EOAuth2ServiceRefSourceFunc ref_source,
      gpointer ref_source_user_data,
      gchar** out_access_token,
      gint* out_expires_in,
      GCancellable* cancellable,
      GError** error
    )

#### Description [src]

Reads access token information from the secret store for the `source` and in case it’s expired it refreshes the token, if possible.

Free the returned `out_access_token` with g_free(), when no longer needed.

Available since: 3.28

#### Parameters

`source`

  Type: `ESource`

  An `ESource`.

  The data is owned by the caller of the method.

`ref_source`

  Type: `EOAuth2ServiceRefSourceFunc`

  An `EOAuth2ServiceRefSourceFunc` function to obtain an `ESource`.

`ref_source_user_data`

  Type: `gpointer`

  User data for `ref_source`.

  The argument can be `NULL`.
  The data is owned by the caller of the method.

`out_access_token`

  Type: `gchar**`

  Return location for the access token.

  The argument will be set by the function.
  The caller of the method takes ownership of the returned data, and is responsible for freeing it.
  The value is a NUL terminated UTF-8 string.

`out_expires_in`

  Type: `gint*`

  How many seconds the access token expires in.

  The argument will be set by the function.

`cancellable`

  Type: `GCancellable`

  Optional `GCancellable` object, or `NULL`.

  The argument can be `NULL`.
  The data is owned by the caller of the method.

`error`

  Type: `GError **`

  The return location for a recoverable error.

  The argument can be `NULL`.
  If the return location is not `NULL`, then you must initialize it to a `NULL` `GError*`.
  The argument will be left initialized to `NULL` by the method if there are no errors.
  In case of error, the argument will be set to a newly allocated `GError`; the caller will take ownership of the data, and be responsible for freeing it.

#### Return value

Type: `gboolean`

`TRUE`, when the returned access token has been set and it’s not expired, `FALSE` otherwise.